import pygame
import states

try:
    import psyco
    psyco.run()
except:
    pass

pygame.init()

class myfont:
    def __init__(self, fontname, size):
        self.font = pygame.font.Font(fontname, size)
        self.size = size
    def render(self, text, anti, color):
        letters = []
        widths = []
        for chr in text:
            inner = self.font.render(chr, anti, color)
            outline = pygame.Surface([inner.get_width()+3, 
                                      inner.get_height()+3])
            outline = outline.convert_alpha()
            outline.fill([0, 0, 0, 0])
            outer = self.font.render(chr, anti, [0, 0, 0])
            outline.blit(outer, [0, 0])
            outline.blit(outer, [0, 1])
            outline.blit(outer, [0, 2])
            outline.blit(outer, [0, 3])
            outline.blit(outer, [1, 0])
            outline.blit(outer, [1, 2])
            outline.blit(outer, [1, 3])
            outline.blit(outer, [2, 0])
            outline.blit(outer, [3, 0])
            outline.blit(outer, [2, 1])
            outline.blit(outer, [3, 1])
            outline.blit(outer, [2, 1])
            outline.blit(outer, [3, 1])
            outline.blit(outer, [2, 2])
            outline.blit(outer, [3, 2])
            outline.blit(outer, [2, 3])
            outline.blit(outer, [3, 3])
            outline.blit(inner, [1, 1])
            letters.append(outline)
            widths.append(self.font.metrics(chr)[0][4])
        w=h=0
        for i,l in enumerate(letters):
            w+=widths[i]
            h2 = l.get_height()
            if h2>h:
                h = h2
        surf = pygame.Surface([w+4, h]).convert_alpha()
        surf.fill([0, 0, 0, 0])
        x = 0
        for l in letters:
            surf.blit(l, [x, 0])
            x += widths.pop(0)
        return surf

def run():
    pygame.screen = pygame.display.set_mode([640,480],0,16)
    pygame.font18 = myfont("gfx/we.ttf", 22)
    pygame.state = states.Intro()
    while pygame.state:
        pygame.state.loop()
