#Functions in here to initialize each room

import room
import sprite
import pygame

def build_room(self, char_pos, bg, walk, fg):
    if hasattr(self, "suited"):
        self.char = sprite.Sprite("gfx/suitmoe.png")
    else:
        self.char = sprite.Sprite("gfx/moe.png")
    self.char.mainseq = [{'rect': [0, 0, 60, 120]}]
    self.char.leftseq = [{'rect': [0, 0, 60, 120]},
        {'rect': [60, 0, 60, 120]}]
    self.char.rightseq = [{'rect': [0, 0, 60, 120]},
        {'rect': [60, 0, 60, 120]}]
    self.char.seq = self.char.mainseq
    self.char.ftime = 100
    self.char.get_image()
    self.char.set_feet()
    self.char.pos = char_pos
    self.char.name = "Moe"
    self.char.click = lambda *args: self.say(self.char, "I look funny.")
    def use_pizza(self, char, it, ob):
        self.items.remove(it)
        self.say(char, "There, now my hair is shiny and firm.\nI'll be sure to impress my customers.")
        self.greased = True
    setattr(self.char, "use_Pizza", use_pizza)
    def use_suit(self, char, it, ob):
        if hasattr(it, "nohanger"):
            self.items.remove(it)
            self.say(char, "It SUITS me.")
            self.suited = True
            self.char.load("gfx/suitmoe.png")
        else:
            self.say(char, "I don't want to HANG(er) myself.")
    setattr(self.char, "use_Suit", use_suit)
    self.room = room.Room(bg, walk, fg)
    self.room.add(self.char)

def pickup(self, char, ob, say=True):
    setattr(self, "got_"+ob.name, True)
    self.items.append(ob)
    self.room.remove(ob)
    if say:
        self.say(char, "I got it.")
    ob.set_corner()
    ob.rightclick = lambda char: self.use(char, ob)
    print "created", ob
    print self.items
    return ob

def walk_and_pickup(self, char, ob):
    d = ob.pos
    if hasattr(ob, "destination"):
        d = ob.destination
    if not self.room.can_walk(d):
        self.say(char, "I can't get to it.")
        return
    p = self.room.astar(char.pos, d)
    if not p:
        self.say(char, "I can't get to it.")
        return
    self.room.clear_paths(char)
    path = self.room.add_path(char, p)
    path["next"] = lambda: pickup(self, char, ob)
    
def walk_and_do(self, char, ob, do):
    d = ob.pos
    if hasattr(ob, "destination"):
        d = ob.destination
    if not self.room.can_walk(d):
        self.say(char, "I can't get to it.")
        return
    p = self.room.astar(char.pos, d)
    if not p:
        self.say(char, "I can't get to it.")
        return
    self.room.clear_paths(char)
    path = self.room.add_path(char, p)
    path["next"] = lambda: do(char)
def useaction(ob, func):
    return lambda self, char, it, ob: walk_and_do(self, self.char, ob, lambda char: func(char, it))

def testroom(self):
    build_room(self, [150, 400],
        "gfx/tempback.png", "gfx/tempwalk.png", None)
    self.items = []
    sidewalk(self)
    self.lock()
    self.say(self.char, "My mission: sell the contents of this case.\nThis house is the last one for miles.\nI hope the inhabitant will buy.\nOtherwise, I don't get a vacation this year.",
        lambda *args: self.unlock())
    if not hasattr(self, "got_Breifcase"):
        nails = self.item("Breifcase", "gfx/widget.png", [170, 420], 
            "It's what I'm trying to sell.")

def sidewalk(self):
    build_room(self, [150, 400],
        "gfx/rooms/sidewalk.png", "gfx/rooms/sidewalkwalk.png", None)
    hobo = self.item("Hobo", "gfx/charlie2.png", [586, 376], 
        "This guy, don't care for his type.\nLooks like he might be helpful though.")
    def talkhobo(char):
        self.lock()
        char.message = ""
        self.say(char, "Hello?", 
        lambda *args: self.say(hobo, "Welcome to my shop <hic>\nGive me something I NEED\nI'll give you your own thing.", 
        self.unlock))
    hobo.rightclick = talkhobo
    def trade(self, char, it, ob):
        self.lock()
        char.message = ""
        def dotrade():
            def finaltrade():
                pickup(self, char, self.item(
                "Trailmix", "gfx/items/trailmix.png", [0,0], "If the hobo was hungry, why didn't he eat these nuts?"))
                self.unlock()
                self.items.remove(it)
            walk_and_do(self, char, hobo, lambda *args: finaltrade())
        self.say(char, "What about this sock?",
        lambda *args: self.say(hobo, "Thanks! I'm starving!\nHow about this trail mix?",
        lambda *args: dotrade()))
    setattr(hobo, "use_Stinky Sock", trade)
    def trade(self, char, it, ob):
        self.lock()
        char.message = ""
        def dotrade():
            self.unlock()
            self.items.remove(it)
            walk_and_do(self, char, hobo, lambda *args: pickup(self, char, self.item(
                "Pizza", "gfx/pizza.png", [0,0], "Nice hat. A bit greasy though.")))
        self.say(char, "Would you care for a ladder?",
        lambda *args: self.say(hobo, "Thanks! I'm STILL starving!\nYou can have my old hat.\nIt won't stay on my head.",
        lambda *args: dotrade()))
    setattr(hobo, "use_ladder", trade)
    fencehole = self.item("enter", "gfx/rooms/fencehole.png", [98, 377],"")
    fencehole.rightclick = fencehole.warp(self, car, [317, 426])
    gate = self.item("enter", "gfx/rooms/gate.png", [313, 343], "")
    gate.rightclick = gate.warp(self, frontlawn, [156,472])
    gate.destination = [313, 360]
    
def car(self):
    build_room(self, [150, 400],
        "gfx/rooms/car/car.png", "gfx/rooms/car/carwalk.png", None)
    cardoor = self.item("Car door", "gfx/rooms/car/cardoor.png", [255, 263],
                "It's the door of the inhabitants lovely vehicle")
    cardoor.rightclick = lambda *args: self.say(self.char, "I think it's locked. I hate locked doors.")
    gastank = self.item("Gastank", "gfx/rooms/car/gastank.png", [360, 205], "Access to fuel compartment")
    gastank.rightclick = lambda *args: self.say(self.char, "I don't want gas in my pocket.")
    treehole = self.item("Hole", "gfx/rooms/car/treehole.png", [492, 97], "I wonder what's in there?")
    treehole.rightclick = lambda *args: walk_and_do(self, self.char, treehole, lambda *args: self.say(self.char, "Looks like there is a squirrel in there.\nHow can I lure him out?"))
    east = self.item("walk east", "gfx/rooms/car/east.png", [617, 0], "")
    east.rightclick = east.warp(self, frontlawn, [9, 224])
    east.set_corner()
    east.destination = [630, 220]
    south = self.item("walk south", "gfx/rooms/car/south.png", [320, 480], "")
    south.rightclick = south.warp(self, sidewalk, [94, 358])
    south.destination = [320, 440]
    def unlockcar(char, it):
        if hasattr(self, "carunlock"):
            self.say(char, "There's nothing left in here")
            return
        self.say(char, "Ah, this coat hanger should do the trick. \n Good, now to see what's inside. \n a Stinky sock!!! what........the.....heck!")
        self.carunlock = True
        self.items.remove(it)
        pickup(self, char, self.item("Stinky Sock", "gfx/items/sock.png", [0,0],
                "Eww, this smells terrible.\n Who the heck would leave this laying around in their car?"), False)
        snh = pickup(self, char, self.item("Suit", "gfx/items/suitnohanger.png", [0,0],
                "This is a nice suit.\nA bit smelly though."), False)
        snh.nohanger = True
    cardoor.use_Suit = lambda self, char, it, ob: walk_and_do(self, self.char, cardoor, lambda char: unlockcar(char, it)) 
    cardoor.destination = [327,317]
    def treesquirel(char, it):
        if hasattr(self, "hassquirel"):
            self.say(char, "There's nothing left in here")
            return
        self.say(char, "Here squirel squirel squirel! \n  *the squirel wanders out of the treehole and eats the trailmix. \nIt then starts to follow you most likely hoping for more food*")
        self.squirel = True
        self.items.remove(it)
        Squirel = self.item("Squirel", "gfx/items/squirel.png", [0,0],
                "Its a squirel. Its staring at me, creepy! \n He looks pretty tired.")
        pickup(self, char, Squirel, False)
        def combinedsquirel(char, it):
            if hasattr(self, "combinedsquirel"):
                return
            self.say(char, "Drink up squirel! *the squirel gulps down the soda.*\n* it starts to get really gittery*\nYikes, this little guy got hyper off the soda!")
            self.combinedsquirel = True
            self.items.remove(it)
            self.items.remove(Squirel)
            squirel = self.item("HyperSquirel", "gfx/items/squirel.png", [0,0],
                    "Yikes, this guy looks like he could run circles around me!")
            pickup(self, char, squirel, False)
        Squirel.use_Soda = lambda self, char, it, ob: combinedsquirel(char, it)
    treehole.use_Trailmix = lambda self, char, it, ob: walk_and_do(self, self.char, treehole, lambda char: treesquirel(char, it)) 
    treehole.destination = [456,278]
    def gasgnome(char, it):
        if hasattr(self, "hasgas"):
            return
        self.say(char, "The lid came right off. I'll just stick the hose in here.\n Ah, the lawn gnome is filling up with gas nicely.")
        self.hasgas = True
        self.items.remove(it)
        Gnome = self.item("lawngnome(gas)", "gfx/items/hollowgnomegas.png", [0,0],
                "The Gnome is full of cas I took from the car.")
        pickup(self, char, Gnome, False)
    gastank.use_lawngnome = lambda self, char, it, ob: walk_and_do(self, self.char, gastank, lambda char: gasgnome(char, it)) 
    gastank.destination = [456,278]
    
def frontlawn(self):
    build_room(self, [150, 400],
        "gfx/rooms/frontlawn/frontlawn.png", "gfx/rooms/frontlawn/frontlawnwalk.png", None)
    west = self.item("walk west", "gfx/rooms/frontlawn/west.png", [0, 0], "")
    west.rightclick = west.warp(self, car, [621, 295])
    west.set_corner()
    west.destination = [0, 220]
    out = self.item("go out gate", "gfx/rooms/frontlawn/out.png", [171, 479], "")
    out.rightclick = out.warp(self, sidewalk, [313, 356])
    out.destination = [171, 460]
    side = self.item("side of the house", "gfx/rooms/frontlawn/side.png", [592, 46], "")
    side.rightclick = side.warp(self, rightside, [15, 382])
    side.destination = [590, 220]
    side.set_corner()
    if not hasattr(self, "doggone"):
        dog = self.item("Guard dog", "gfx/rooms/frontlawn/dog.png", [408, 134],
            "The dog is glaring at me.", False)
        dog.rightclick = lambda char: self.say(char, "I'm not going NEAR that dog.\nWithout a distraction at least.")
        def use_squirel(char, it):
            self.lock()
            self.items.remove(it)
            self.room.add(it)
            it.flipped = True
            it.seq = [{"rect":it.image.get_rect()}]
            it.pos = [226, 95]
            squirelpath = self.room.add_path(it, [[-50, 95]], False)
            dogpath = self.room.add_path(dog, [[-50, 95]], False)
            dogpath["next"] = lambda: self.unlock()
            self.doggone = True
        dog.use_hypersquirel = useaction(dog, use_squirel)
        dog.use_squirel = lambda *args: self.say(self.char, "He looks too tired.\nThe dog will just eat him and then where will I be?")
    porcho = self.item("Porch", "gfx/rooms/frontlawn/porch.png", [393, 0], "")
    porcho.set_corner()
    porcho.destination = [438, 62]
    def tryporch(char):
        if hasattr(self, "doggone"):
            porcho.warp(self, porch, [237, 405])(char)
            return
        self.say(char, "I am not going to try and get by that dog.\nI hate dogs.")
    porcho.rightclick = tryporch
    porcho.leftclick = tryporch
    if not hasattr(self, "got_Lawngnome"):
        lawngnome = self.item("Lawngnome", "gfx/items/hollowgnome.png", [322, 407],
            "Its a lawn gnome watering can. Its scaring the heck out of me!")
        def combinedgnome(char, it):
            if hasattr(self, "combinedgnome"):
                return
            self.say(char, "It looks like this gnome has a spot on the side of him \n to attach a hose. \n Ah, there we go. It fits just perfectly")
            self.combinedgnome = True
            self.items.remove(it)
            self.items.remove(lawngnome)
            pickup(self, char, self.item("lawngnome", "gfx/items/hollowgnome.png", [0,0],
                    "A lawn gnome with a hose attached to it, pretty neato."), False)
        lawngnome.use_Hose = lambda self, char, it, ob: combinedgnome(char, it)
    
def cellar(self):
    if hasattr(self, "bearwoke"):
        build_room(self, [320, 466],
            "gfx/cellar.png", "gfx/cellarwakewalk.png", None)
        bear = self.item("Working bear", "gfx/bearwoke.png", [500, 424],
                    "Life is good when you have a bear.", False)
    else:
        build_room(self, [320, 466],
            "gfx/cellar.png", "gfx/cellarsleepwalk.png", None)
        bear = self.item("Sleeping bear", "gfx/bearsleep.png", [473, 445],
                    "I'd better beware, it's a sleeping bear.", False)
        def wake(char):
            self.bearwoke = True
            self.items[:] = [i for i in self.items if i.name != "Pizza"]
            cellar(self)
            self.say(self.char, "He woke up.\nI think he likes the pizza!")
        bear.rightclick = lambda char: self.say(char, 
                                    "Not such a good idea.")
        bear.use_Pizza = lambda self, char, *args: wake(char)
    
def rightside(self):
    build_room(self, [150, 400],
        "gfx/rooms/rightside/rightside.png", "gfx/rooms/rightside/rightsidewalk.png", None)
    front = self.item("to the front yard", "gfx/rooms/rightside/front.png", [0, 291], "")
    front.set_corner()
    front.rightclick = front.warp(self, frontlawn, [597, 284])
    front.destination = [5, 340]
    back = self.item("to the back yard", "gfx/rooms/rightside/back.png", [576, 293], "")
    back.set_corner()
    back.rightclick = back.warp(self, backyard, [600, 311])
    back.destination = [576, 340]
    #cellard = self.item("enter cellar", "gfx/rooms/rightside/cellar.png", [350, 321], "")
    #cellard.rightclick = cellard.warp(self, cellar, [324, 441])
    #cellard.destination = [350, 340]
    lawnmower = self.item("Lawnmower", "gfx/rooms/rightside/lawnmower.png", [541, 465],
        "A gas-powered lawn mower.")
    def mow(*args):
        if hasattr(self, "mowed"):
            self.say(self.char, "The lawn is already cut.")
        elif hasattr(self, "gasfilled"):
            self.mowed = True
            self.lock()
            def animate(*args):
                self.room.add_path(lawnmower, [[64, 406]], False)
                path = self.room.add_path(self.char, [[124, 426]], False)
                def getkey():
                    self.say(self.char, "Wow, I find a key in the grass!")
                    pickup(self, self.char, self.item("Key", "gfx/items/key.png", [0,0],
                        "Some key to some door somewhere."), False)
                    self.unlock()
                path["next"] = lambda *args: getkey()
            walk_and_do(self, self.char, lawnmower, animate)
        else:
            self.say(self.char, "It has no gas.")
    lawnmower.rightclick = mow
    lawnmower.destination = [lawnmower.pos[0]+60, lawnmower.pos[1]-20]
    def fill(char, it):
        self.items.remove(it)
        self.gasfilled = True
        self.say(self.char, "I emptied the gas into the mower.")
    setattr(lawnmower, "use_lawngnome(gas)", useaction(lawnmower, fill))

def backyard(self):
    build_room(self, [150, 400],
        "gfx/rooms/backyard/backyard.png", "gfx/rooms/backyard/backyardwalk.png", None)
    trashcan = self.item("Trashcan", "gfx/rooms/backyard/trashcan.png", [230, 410],
        """A trashcan. I hate trashcans.""")
    def search(char):
        self.say(char, "Hmm.\nI found a nice suit.\nAnd also this soda.\nIt's not empty!")
        pickup(self, char, self.item("Soda", "gfx/items/soda.png", [0,0], 
                "A can of soda."), False)
        pickup(self, char, self.item("Suit", "gfx/items/suit.png", [0,0],
                "This is a suit. It is still on a hanger.\n Who would toss this?"), False)
        self.searchedcan = True
    def git(char):
        if hasattr(self, "searchedcan"):
            self.say(char, "I'm not doing that again.")
        else:
            walk_and_do(self, char, trashcan, search)
    trashcan.rightclick = lambda char: git(char)
    right = self.item("Walk right", "gfx/rooms/backyard/right.png", [557, 169], "")
    right.set_corner()
    right.rightclick = right.warp(self, rightside, [598, 391])
    right.destination = right.pos
    right.destination[1] += 100
    shedo = self.item("Shed", "gfx/rooms/backyard/shed.png", [195, 203],
            "Looks like a shed. I hate sheds.\nEspecially locked ones.")
    shedo.offset = [197, 162]
    shedo.destination = [220, 220]
    def doshed(char):
        if hasattr(self, "shedunlock"):
            shedo.warp(self, shed, [309, 448])(char)
            return
        self.say(char, "The shed is locked foo.")
    shedo.rightclick = doshed
    def unlockshed(self, char, it, ob):
        if hasattr(self, "shedunlock"):
            self.say(char, "It's already unlocked")
            return
        self.say(char, "It unlocked the shed.")
        self.shedunlock = True
    shedo.use_Key = unlockshed
    if not hasattr(self, "got_Hose"):
        hose = self.item("Hose", "gfx/items/hose.png", [460, 260], 
            "A hose. It looks like its been used recently.")

    
def shed(self):
    build_room(self, [150, 400],
        "gfx/rooms/shed/shed.png", "gfx/rooms/shed/shedwalk.png", None)
    yard = self.item("exit", "gfx/rooms/shed/yard.png", [320, 479], "")
    yard.destination = [320, 470]
    yard.rightclick = yard.warp(self, backyard)
    if not hasattr(self, "got_Hammer"):
        hammer = self.item("Hammer", "gfx/items/hammer.png", [160, 260], 
            "Its a hammer and a good one at that\n you could do some serious damage\n with one of these!")
        hammer.destination = [217, 276]
    if not hasattr(self, "got_Boards"):
        boards= self.item("Boards", "gfx/items/boards.png", [460, 260], 
            "Some boards, these could be usefull.")
        boards.destination = [360, 276]
    if not hasattr(self, "got_Nails"):
        nails= self.item("Nails", "gfx/items/nails.png", [480, 280], 
            "Some nails, these could be usefull.")
        nails.destination = [360, 276]
    if not hasattr(self, "gotladder"):
        ladder = self.item("ladder", "gfx/rooms/shed/ladder.png", [300, 280], "")
        def pickladder(char):
            pickup(self, char, self.item("Ladder", "gfx/items/laddericon.png", [0,0], 
                    "A Ladder, I'm not to fond of these things."))
            self.room.remove(ladder)
            self.gotladder = True
        ladder.rightclick = pickladder
    
def porch(self):
    build_room(self, [255, 406],
        "gfx/rooms/porch/porch.png", "gfx/rooms/porch/porchwalk.png", None)
    windows = self.item("Windows", "gfx/rooms/porch/windows.png", [0,0], "")
    def look_windows(char):
        self.say(char, "You can't see anything through the windows.")
    windows.click = look_windows
    windows.rightclick = lambda char: self.say(char, "I don't think I can open them.")
    windows.set_corner()
    exit = self.item("Exit", "gfx/rooms/porch/exit.png", [132, 434], "")
    exit.rightclick = exit.warp(self, frontlawn, [419, 84])
    exit.set_corner()
    exit.destination = [249, 412]
    if hasattr(self, "seentrap"):
        trapdoor = self.item("Trapdoor", "gfx/rooms/porch/trap.png", [294, 350], "This is where I fall when I push the doorbell.")
        trapdoor.rightclick = lambda *args: self.say(self.char, "I need tools to block it.")
        if not hasattr(self, "traporder"):
            self.traporder = ["Boards", "Nails", "Hammer"]
        def use_me(item):
            if item.name != self.traporder[0]:
                self.say(self.char, "I don't think that is quite correct.")
                return
            if not hasattr(self, "used_"+item.name):
                setattr(self, "used_"+item.name, True)
                self.items.remove(item)
                del self.traporder[0]
                if not self.traporder:
                    self.trapdoor_boarded = True
                    self.say(self.char, "There. The trapdoor is boarded up solid")
        trapdoor.use_Boards = useaction(trapdoor, lambda char, it: use_me(it))
        trapdoor.use_Nails = useaction(trapdoor, lambda char, it: use_me(it))
        trapdoor.use_Hammer = useaction(trapdoor, lambda char, it: use_me(it))
    doorbell = self.item("Doorbell", "gfx/rooms/porch/doorbell.png", [384, 194],
        "It's a doorbell. I hate doorbells.")
    def make_henry1():
        henry = self.item("Henry", "gfx/henry.png", [325, 326],
            "Some old dude. I hate old dudes.")
        self.say(henry, "HI THERE! PEPPERMINT?")
        henry.rightclick = lambda *args: self.say(self.char, "I should try to sell the goods.")
        henry.destination = [253, 362]
        def sell(char, it):
            self.lock()
            def to_sidewalk():
                self.unlock()
                sidewalk(self)
            if hasattr(self, "greased") and hasattr(self, "suited"):
                def swap():
                    self.items.remove(it)
                    sidewalk(self)
                    self.say(self.char, "Well, that's that done.\nI have succeeded in my mission.\nI can now look forward to my first vacation ever!\nDid I mention I hate this job?\n(THE END)", lambda *args: self.unlock())
                self.say(henry, "MY LAWD! A RESPECTABLE BUSINESS MAN!\nI HAVEN'T HAD THE PLEASURE IN MUCH TIME!\nI LOVE TO BUY FINE PRODUCTS!\nLET ME SEE WHAT YOU GOT SONNY!",
                lambda *args: self.say(char, "The product is in the case\nif you care to take a look.",
                lambda *args: self.say(henry, "WOW! I'LL TAKE IT! NOW GET OFF MY LAWN!", 
                lambda *args: swap())))
            elif hasattr(self, "suited"):
                self.say(henry, "CATCHY SUIT! UGLY HAIR! GET OFF MY LAWN!",
                lambda *args: to_sidewalk())
            elif hasattr(self, "greased"):
                self.say(henry, "SLICK HAIR! FUGLY CLOTHES! GET OFF MY LAWN!",
                lambda *args: to_sidewalk())
            else:
                self.say(henry, "BUSINESSMEN THESE DAYS HAVE NO RESPECT!\nIN MY DAY THEY HAD SHINY HAIR!\nAND SPIFFY SUITS TO MATCH!\nGET OFF MY LAWN!!!",
                lambda *args: to_sidewalk())
        henry.use_breifcase = useaction(henry, sell)
    def ring(char):
        if not hasattr(self, "trapdoor_boarded"):
            self.seentrap = True
            self.lock()
            self.item("", "gfx/rooms/porch/stair_foreground.png", [320, 480], "")
            self.say(doorbell, "RIIIING")
            def warp():
                sidewalk(self)
                self.char.pos = [432, 450]
                self.event = lambda *args: self.say(self.char, "I FELL for the trapdoor gag.", lambda *args: self.unlock())
                self.event.time = 45
            def trapdoor(*args):
                self.room.add_path(char, [[320, 480]], False)
                self.room.event = warp
                self.room.event.time = 50
            self.say(char, "AHHHHH!", trapdoor)
            return
        self.say(doorbell, "RIIIING")
        if not hasattr(self, "henry"):
            path = self.room.add_path(self.char, [[249, 362], [253, 362]], False)
            path["next"] = lambda *args: setattr(self.char, "flipped", False)
            self.room.event = make_henry1
            self.room.event.time = 100
    doorbell.rightclick = lambda char: walk_and_do(self, char, doorbell, ring)
    doorbell.destination = [300, 331]