import pygame

class Sprite(object):
    
    def __init__(self, path=None):
        self.image = None
        if path:
            self.load(path)
        self.pos = [0, 0]
        self.offset = [0, 0]
        self.message = ""
        self.message_time = 0
        self.color = [120, 125, 255]
        self.seq = []
        self.ftime = 0
        self.flipped = 0
        
    def warp(self, state, destination, position=None):
        self.click = lambda *args: self.rightclick(*args)
        from cod.rooms import walk_and_do
        def gothere(state):
            destination(state)
            if position:
                state.char.pos = position
        return lambda char: walk_and_do(state, state.char, self, lambda char: gothere(state))
    
    def load(self, path):
        self.surface = pygame.image.load(path)
        self.surface = self.surface.convert_alpha()
        self.image = self.surface

    def set_feet(self):
        """Sets the offset at the foot of the image"""
        self.offset = [self.image.get_width()//2,
                self.image.get_height()]

    def set_corner(self):
        self.offset = [0, 0]
        
    def get_image(self):
        if self.seq:
            self.ftime += 1
            if self.ftime > 2:
                self.ftime = 0
                self.seq.append(self.seq.pop(0))
                if self.seq[0] == None:
                    self.seq = []
                else:
                    self.image = self.surface.subsurface(self.seq[0]['rect'])
                    if self.flipped:
                        self.image = pygame.transform.flip(self.image, 1, 0)

    def draw(self):
        if not self.image:
            return
        self.get_image()
        pygame.screen.blit(self.image, 
                [self.pos[0]-self.offset[0],
                 self.pos[1]-self.offset[1]])
        if self.message:
            if self.message_time:
                self.message_time -= 1
                if self.message_time <= 0:
                    self.message = ""
                    if hasattr(self, "when_msg_over"):
                        f = self.when_msg_over
                        del self.when_msg_over
                        f(self)
            if self.message:
                if isinstance(self.message, str):
                    self.message = pygame.font18.render(self.message, 
                                                    1, self.color)
                txt = self.message
                p = [self.pos[0]-self.offset[0]-txt.get_width()//2+self.image.get_width()//2,
 self.pos[1]-self.offset[1]-14]
                if p[0]<0: p[0] = 0
                if p[0]+txt.get_width()>640: p[0] = 640-txt.get_width()
                if p[1]<0: p[1] = 0
                if p[1]+txt.get_height()>480: p[1] = 480-txt.get_height()
                pygame.screen.blit(txt, p)
